SystemOrganization addCategory: #'O-Core-Misc'!

Interval subclass: #OstInterval
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstInterval methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:47'!
species
	^ OstArray! !

Rectangle subclass: #OstRectangle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstRectangle methodsFor: 'rectangle functions' stamp: 'StefanMarr 5/30/2013 16:46'!
intersect: aRectangle 
	"Answer a Rectangle that is the area in which the receiver overlaps with 
	aRectangle. Optimized for speed; old code read:
		^Rectangle 
			origin: (origin max: aRectangle origin)
			corner: (corner min: aRectangle corner)
	"
	| aPoint left right top bottom |
	aPoint := aRectangle origin.
	aPoint x > origin x 
		ifTrue: [ left := aPoint x ]
		ifFalse: [ left := origin x ].
	aPoint y > origin y 
		ifTrue: [ top := aPoint y ]
		ifFalse: [ top := origin y ].
	aPoint := aRectangle corner.
	aPoint x < corner x 
		ifTrue: [ right := aPoint x ]
		ifFalse: [ right := corner x ].
	aPoint y < corner y 
		ifTrue: [ bottom := aPoint y ]
		ifFalse: [ bottom := corner y ].
	^ OstRectangle 
		origin: (OstPoint x: left y: top)
		corner: (OstPoint x: right y: bottom)! !

TestCase subclass: #OstTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstTestCase commentStamp: 'StefanMarr 1/13/2013 14:02' prior: 0!
A dummy class for compatibibility with the Omni system.
In case you load omni into this image, this class can be overwritten.!

Monitor subclass: #OstMonitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstMonitor methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:46'!
defaultQueue
	defaultQueue ifNil: [defaultQueue := OstOrderedCollection new].
	^ defaultQueue! !

!OstMonitor methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:47'!
queueDict
	^ queueDict ifNil: [queueDict := OstIdentityDictionary new].! !

Association subclass: #OstAssociation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

Dictionary subclass: #OstDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstDictionary class methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:49'!
arrayType
	^ OstArray! !

!OstDictionary methodsFor: 'accessing' stamp: 'StefanMarr 5/30/2013 16:48'!
at: key put: anObject 
	"Set the value at key to be anObject.  If key is not found, create a
	new entry for key and set is value to anObject. Answer anObject."

	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	assoc
		ifNil: [self atNewIndex: index put: (OstAssociation key: key value: anObject)]
		ifNotNil: [assoc value: anObject].
	^ anObject! !

IdentityDictionary subclass: #OstIdentityDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstIdentityDictionary class methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:50'!
arrayType
	^ OstArray! !

SortedCollection subclass: #OstSortedCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstSortedCollection class methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:44'!
arrayType
	^ OstArray! !

Point subclass: #OstPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

Array variableSubclass: #OstArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstArray commentStamp: 'StefanMarr 1/13/2013 14:02' prior: 0!
A dummy class for compatibibility with the Omni system.
In case you load omni into this image, this class can be overwritten.!

!OstArray class methodsFor: 'instance creation' stamp: 'StefanMarr 5/31/2013 00:29'!
fromArray: anArray
	| array index |
	array := self new: anArray size.
	index := 0.
	anArray do: [:each | array at: (index := index + 1) put: each].
	^ array! !

OrderedCollection subclass: #OstOrderedCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstOrderedCollection class methodsFor: 'private' stamp: 'StefanMarr 5/30/2013 16:51'!
arrayType
	^ OstArray! !

SharedQueue subclass: #OstSharedQueue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstSharedQueue methodsFor: 'initializing' stamp: 'StefanMarr 5/30/2013 16:45'!
initialize
	monitor := OstMonitor new.
	items   := OstOrderedCollection new.! !

Object subclass: #OstObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstObject commentStamp: 'StefanMarr 1/4/2012 14:19' prior: 0!
A dummy class for compatibibility with the Omni system.
In case you load omni into this image, this class can be overwritten.!

!OstObject class methodsFor: 'OmniST-compatibility' stamp: 'StefanMarr 9/8/2012 09:55'!
omnifyClass: aClass
	"Only here for compatibility"
	^ aClass! !

Set subclass: #OstSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Core-Misc'!

!OstSet class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 5/30/2013 16:46'!
arrayType
	^ OstArray! !

!OstSet methodsFor: 'converting' stamp: 'StefanMarr 5/30/2013 16:45'!
asArray
	"Answer an Array whose elements are the elements of the receiver.
	Implementation note: Cannot use ''Array withAll: self'' as that only
	works for SequenceableCollections which support the replacement 
	primitive."

	| arr index |
	arr := OstArray new: self size.
	index := 0.
	self do: [:each | arr at: (index := index + 1) put: each].
	^ arr! !
